int xhash_init(char *xpath);
char *xhash_fname(int gid, int bkt);
char *xhash_path(int gid);
int xhash_bucket(int n, int *bucket, int *h);
int xhash_close(void);
int xhash_open(int gid, int bucket, int iswrite, char *reason);
int xhash_get(int gid, int n, char *xline, int bfsz, int *retsz, char *reason);
int xhash_add(int gid, int n, char *xline, int len,  char *reason);
int xhash_expire(int grp, int gid, int min, int max, int delall);
int xhash_remove(int gid, char *fname);
int xhash_delete(int gid);
